<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__crypto" kind="group">
    <compoundname>group_crypto</compoundname>
    <title>Crypto       (Cryptography)</title>
    <innergroup refid="group__group__crypto__cli__srv">Client-Server Model</innergroup>
    <innergroup refid="group__group__crypto__lld__api">Direct Crypto Core Access</innergroup>
    <innergroup refid="group__group__crypto__data__structures">Common Data Structures</innergroup>
    <innergroup refid="group__group__crypto__enums">Common Enumerated Types</innergroup>
    <briefdescription>
<para>The Crypto driver provides a public API to perform cryptographic and hash operations, as well as generate both true and pseudo random numbers. </para>    </briefdescription>
    <detaileddescription>
<para>It uses a hardware IP block to accelerate operations.</para><para>The functions and other declarations used in this driver are in cy_crypto.h, cy_crypto_core.h, and cy_crypto_server.h. You can also include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>The driver implements two usage models:<itemizedlist>
<listitem><para><ref kindref="compound" refid="group__group__crypto__cli__srv">Client-Server Model</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__crypto__lld__api">Direct Crypto Core Access</ref></para></listitem></itemizedlist>
</para><para>Mixing these usage models will result in undefined behaviour.</para><para>The Crypto driver supports these standards: DES, TDES, AES (128, 192, 256 bits), CMAC-AES, SHA, HMAC, PRNG, TRNG, CRC, RSA, ECP, and ECDSA. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;ECP and ECDSA are only implemented for the &lt;a href="group__group__crypto__lld__api.html#"&gt;Direct Crypto Core Access&lt;/a&gt; model.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>Firmware sets up a cryptographic operation by passing in the required data as parameters in the function calls.</para><para>All Crypto functions require a context. A context is a data structure that the driver uses for its operations. Firmware declares a context (allocates memory) but does not write or read the values in that context. In effect, the context is a scratch pad you provide to the driver. The driver uses the context to store and manipulate data during cryptographic operations.</para><para>Several methods require an additional context unique to the particular cryptographic technique. The Crypto driver header files declare all the required structures for both configuration and context.</para><para>Some encryption techniques require additional initialization specific to the technique. If there is an Init function, you must call it before using any other function for that technique, and re-initialize after you use a different encryption technique.</para><para>For example, use <ref kindref="member" refid="group__group__crypto__cli__functions_1gae157d02a1be9a43e944337dd816eb618">Cy_Crypto_Aes_Init</ref> to configure an AES encryption operation with the encryption key, and key length. Provide pointers to two context structures. You can then call the AES Run functions. If you use DES after that, you must re-initialize the AES encryption before using it again.</para>

<para><heading level="1">Definitions</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Term &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Definition &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Plaintext &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;An unencrypted message &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Ciphertext &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;An encrypted message &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Block Cipher &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;An encryption function for fixed-size blocks of data. This function takes a fixed-size key and a block of plaintext data from the message and encrypts it to generate ciphertext. Block ciphers are reversible. The function performed on a block of encrypted data will decrypt that data. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Block Cipher Mode &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A mode of encrypting a message using block ciphers for messages of an arbitrary length. The message is padded so that its length is an integer multiple of the block size. ECB (Electronic Code Book), CBC (Cipher Block Chaining), and CFB (Cipher Feedback) are all modes of using block ciphers to create an encrypted message of an arbitrary length.  &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Data Encryption Standard (DES) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The &lt;a href="https://csrc.nist.gov/csrc/media/publications/fips/46/3/archive/1999-10-25/documents/fips46-3.pdf"&gt;DES standard&lt;/a&gt; specifies a symmetric-key algorithm for encryption of electronic data. It uses a 56-bit key. The block size is 64-bits.  &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Triple DES (3DES or TDES) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The &lt;a href="https://csrc.nist.gov/csrc/media/publications/fips/46/3/archive/1999-10-25/documents/fips46-3.pdf"&gt;TDES standard&lt;/a&gt; specifies a symmetric-key block cipher that applies the Data Encryption Standard (DES) cipher algorithm three times to each data block. It uses three 56-bit keys. The block size is 64-bits.  &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Advanced Encryption Standard (AES) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The &lt;a href="https://nvlpubs.nist.gov/nistpubs/fips/nist.fips.197.pdf"&gt;AES standard&lt;/a&gt; specifies the Rijndael algorithm, a symmetric block cipher that can process 128-bit data blocks, using cipher keys with 128-, 192-, and 256-bit lengths. Rijndael was designed to handle additional block sizes and key lengths. However, they are not adopted in this standard. AES is also used for message authentication.  &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Secure Hash Algorithm (SHA) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cryptographic hash function. This function takes a message of an arbitrary length and reduces it to a fixed-length residue or message digest after performing a series of mathematically defined operations that practically guarantee that any change in the message will change the hash value. It is used for message authentication by transmitting a message with a hash value appended to it and recalculating the message hash value using the same algorithm at the recipient's end. If the hashes differ, then the message is corrupted. For more information see &lt;a href="https://csrc.nist.gov/csrc/media/publications/fips/180/2/archive/2002-08-01/documents/fips180-2.pdf"&gt;Secure Hash standard description&lt;/a&gt;.  &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Message Authentication Code (MAC) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;MACs are used to verify that a received message has not been altered. This is done by first computing a MAC value at the sender's end and appending it to the transmitted message. When the message is received, the MAC is computed again and checked against the MAC value transmitted with the message. If they do not match, the message has been altered. Either a Hash algorithm (such as SHA) or a block cipher (such as AES) can be used to produce the MAC value. Keyed MAC schemes use a Secret Key along with the message, thus the Key value must be known to be able to compute the MAC value. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Cipher-based Message Authentication Code (CMAC) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A block cipher-based message authentication code algorithm. It computes the MAC value using the AES block cipher algorithm. For more information see &lt;a href="https://nvlpubs.nist.gov/nistpubs/specialpublications/nist.sp.800-38b.pdf"&gt;Recommendation for Block Cipher Modes of Operation&lt;/a&gt;. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Hash Message Authentication Code (HMAC) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A specific type of message authentication code (MAC) that involves a cryptographic hash function and a secret cryptographic key. It computes the MAC value using a Hash algorithm. For more information see &lt;a href="https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.198-1.pdf"&gt;The Keyed-Hash Message Authentication Code standard&lt;/a&gt;  &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Pseudo Random Number Generator (PRNG) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A Linear Feedback Shift Registers-based algorithm for generating a sequence of numbers starting from a non-zero seed. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;True Random Number Generator (TRNG) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A block that generates a number that is statistically random and based on some physical random variation. The number cannot be duplicated by running the process again. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Symmetric Key Cryptography &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Uses a common, known key to encrypt and decrypt messages (a shared secret between sender and receiver). An efficient method used for encrypting and decrypting messages after the authenticity of the other party has been established. DES (now obsolete), 3DES, and AES (currently used) are well-known symmetric cryptography methods. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Asymmetric Key Cryptography &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Also referred to as Public Key encryption. To receive a message, you publish a very large public key (up to 4096 bits currently). That key is one of the two prime factors of a very large number. The other prime factor is the recipient's private (secret) key. To send a message to the publisher of the public key, you encrypt the message with the public key. This message can now be decrypted only with the private key (the other prime factor held in secret by the recipient). The message is now sent over any channel to the recipient who can decrypt it with the private (secret) key. The same process is used to send messages to the sender of the original message. The asymmetric cryptography relies on the mathematical impracticality (usually related to the processing power available at any given time) of factoring the keys. Common, computationally intensive, asymmetric algorithms are RSA and ECC. The public key is described by the pair (n, e) where n is a product of two randomly chosen primes p and q. The exponent e is a random integer 1 &amp;lt; e &amp;lt; Q where Q = (p-1) (q-1). The private key d is uniquely defined by the integer 1 &amp;lt; d &amp;lt; Q so that ed congruent with 1 (mod Q ).   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">More Information</heading></para>
<para>RSASSA-PKCS1-v1_5 described here, page 31: <ulink url="http://www.emc.com/collateral/white-papers/h11300-pkcs-1v2-2-rsa-cryptography-standard-wp.pdf">http://www.emc.com/collateral/white-papers/h11300-pkcs-1v2-2-rsa-cryptography-standard-wp.pdf</ulink></para><para>See the "Cryptographic Function Block" chapter of the Technical Reference Manual.</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The Crypto driver has the following specific deviations:</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;8.8 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;An external object or function shall be declared in one and only one file. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The pointer to the operation context memory can not be public accessible (can not be defined in the header file) but it should be extarnally accessed, because it is used by other Cypress software resources.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cast should not be performed between a pointer to object type and a different pointer to object type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The pointers to the context memory are void to allow handling of different data types for different operations. The cast operation is safe because the configuration is verified before operation is performed.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;16.7 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A pointer parameter in a function prototype should be declared as pointer to const if the pointer is not used to modify the addressed object. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The objects pointed to by the base addresses of the CRYPTO are not always modified. While a const qualifier can be used in select scenarios, it brings little benefit in adding this to the affected functions.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;20.6 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The macro offsetof, in library &amp;lt;stddef.h&amp;gt;, shall not be used. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The only HW block register offsets are defined using this macro.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.30.3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.30.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added a C++ namespace guards.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Make a driver code to be compatible with C++.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.30 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;ul&gt;&lt;li&gt;&lt;p&gt;Added a multi-instance support for AES and SHA. &lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Added a small chunks mode for SHA with any chunk size (from one byte). &lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Added the operation memory buffer management (set a new address, get a size). &lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Added a support for ARM Compiler 6. &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Integration with mbedOS/mbedTLS, restructured the implementation of AES and SHA for the Crypto ALT interface.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;ul&gt;&lt;li&gt;&lt;p&gt;Moved from a pre-compiled library to Open Source under Apache 2.0 license. &lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Core (server) This API is now available. &lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Added ECP and ECDSA support for the NIST P curves: SECP192R1, SECP224R1, SECP256R1, SECP384R1, SECP521R1. &lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;ECP and ECDSA only supported with direct calls to Crypto APIs, no client interface functions are present. &lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Added Chunk mode for CRC. &lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Added Chunk mode for SHA, the chunk size is limited to the SHA block size. &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;ECC support added.&lt;br /&gt; Integration with mbedOS/mbedTLS, restructured the implementation of SHA and CRC for the Crypto ALT interface.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.11b &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The same as production 2.10; only the newly-added Elliptic Curve point multiplication functionality (NIST P256) is pre-production. Open source under Apache version 2.0 license. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.11 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Based on pre-production 2.10, except the newly-added Elliptic Curve point multiplication functionality (NIST P256). Does not incorporate the production level documentation. Open source under Apache version 2.0 license. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;ECC support.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.10b &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The same as production 2.10. Open source under Apache version 2.0 license. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="4"&gt;&lt;p&gt;2.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Removed files with the default driver configuration. &lt;br /&gt; Added API functions to start different server functionality:&lt;ul&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__crypto__srv__functions.html#group__group__crypto__srv__functions_1ga20467da28097037178b4e9a2bb16095c"&gt;Cy_Crypto_Server_Start_Base&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__crypto__srv__functions.html#group__group__crypto__srv__functions_1gaccdace40a137ec8634f6f2114832e162"&gt;Cy_Crypto_Server_Start_Extra&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__crypto__srv__functions.html#group__group__crypto__srv__functions_1gaf91c7e2d0fd473dd35d8e1df05e5c7f5"&gt;Cy_Crypto_Server_Start_Full&lt;/a&gt;  &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added the register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added precompiled libraries for the IAR toolchain. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;IAR toolchain support in ModusToolbox.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.0b &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The same as production 2.0. Open source under Apache version 2.0 license. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;2.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Clarified what parameters must be 4-byte aligned for the functions: &lt;a href="group__group__crypto__cli__functions.html#group__group__crypto__cli__functions_1gadce7e0725bf4da6b0a597e60a615f5f8"&gt;Cy_Crypto_Aes_Cmac_Run&lt;/a&gt;, &lt;a href="group__group__crypto__cli__functions.html#group__group__crypto__cli__functions_1ga81fe41f71b97c14e6a4aefcaa78e3378"&gt;Cy_Crypto_Sha_Run&lt;/a&gt;, &lt;a href="group__group__crypto__cli__functions.html#group__group__crypto__cli__functions_1ga00f0ec4cac3b873b30ac5c4793f3c1d4"&gt;Cy_Crypto_Hmac_Run&lt;/a&gt;, &lt;a href="group__group__crypto__cli__functions.html#group__group__crypto__cli__functions_1ga1f6950833770e1f2b932f089fcd126b2"&gt;Cy_Crypto_Str_MemCmp&lt;/a&gt;, &lt;a href="group__group__crypto__cli__functions.html#group__group__crypto__cli__functions_1ga69061dfb8a8ccd707edf8151e1427987"&gt;Cy_Crypto_Trng_Generate&lt;/a&gt;, &lt;a href="group__group__crypto__cli__functions.html#group__group__crypto__cli__functions_1gab5ab6f272d15ebb2fb14000530b6d29a"&gt;Cy_Crypto_Des_Run&lt;/a&gt;, &lt;a href="group__group__crypto__cli__functions.html#group__group__crypto__cli__functions_1ga86c02f38711df37a1ca8f9b505ad5f2c"&gt;Cy_Crypto_Tdes_Run&lt;/a&gt;, &lt;a href="group__group__crypto__cli__functions.html#group__group__crypto__cli__functions_1gac73a47f8656e1056686f461c68956fed"&gt;Cy_Crypto_Rsa_Proc&lt;/a&gt;  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Changed crypto IP power control.&lt;br /&gt; Enhanced Vector Unit functionality for RSA crypto algorithm.&lt;br /&gt; Added support of the single-core devices.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;New device support.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>